"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MCPToolkit = void 0;
const index_js_1 = require("../../../database/index.js");
const addAccessPatternTool_js_1 = require("./addAccessPatternTool.js");
const index_js_2 = require("./addEntityTools/index.js");
class MCPToolkit extends index_js_1.DatabaseAction {
    addTools(mcpServer, options = {}) {
        for (const [dbTableKey, dbTable] of Object.entries(this.database.tables)) {
            for (const entity of Object.values(dbTable.entities)) {
                (0, index_js_2.addEntityTools)(mcpServer, entity, { ...options, dbTableKey });
            }
            for (const [dbAccessPatternKey, accessPattern] of Object.entries(dbTable.accessPatterns)) {
                (0, addAccessPatternTool_js_1.addAccessPatternTool)(mcpServer, accessPattern, { dbTableKey, dbAccessPatternKey });
            }
        }
        return this;
    }
}
exports.MCPToolkit = MCPToolkit;
