import type { BatchWriteCommandInput } from '@aws-sdk/lib-dynamodb';
import { EntityAction } from '../../../entity/index.js';
import type { Entity, KeyInputItem } from '../../../entity/index.js';
import { $key } from './constants.js';
export declare class BatchDeleteRequest<ENTITY extends Entity = Entity> extends EntityAction<ENTITY> {
    static actionName: "batchDelete";
    [$key]?: KeyInputItem<ENTITY>;
    constructor(entity: ENTITY, key?: KeyInputItem<ENTITY>);
    key(nextKey: KeyInputItem<ENTITY>): BatchDeleteRequest<ENTITY>;
    params(): NonNullable<BatchWriteCommandInput['RequestItems']>[string][number];
}
