import type { BatchGetCommandInput } from '@aws-sdk/lib-dynamodb';
import { EntityAction } from '../../../entity/index.js';
import type { Entity, KeyInputItem } from '../../../entity/index.js';
import { $key } from './constants.js';
export declare class BatchGetRequest<ENTITY extends Entity = Entity> extends EntityAction<ENTITY> {
    static actionName: "batchGet";
    [$key]?: KeyInputItem<ENTITY>;
    constructor(entity: ENTITY, key?: KeyInputItem<ENTITY>);
    key(nextKey: KeyInputItem<ENTITY>): BatchGetRequest<ENTITY>;
    params(): NonNullable<NonNullable<BatchGetCommandInput['RequestItems']>[string]['Keys']>[number];
}
