import type { Condition } from '../../../entity/actions/parseCondition/index.js';
import type { Entity } from '../../../entity/index.js';
import type { CapacityOption } from '../../../options/capacity.js';
import type { MetricsOption } from '../../../options/metrics.js';
import type { AllOldReturnValuesOption, NoneReturnValuesOption } from '../../../options/returnValues.js';
import type { ReturnValuesOnConditionFalseOption } from '../../../options/returnValuesOnConditionFalse.js';
export type PutItemCommandReturnValuesOption = NoneReturnValuesOption | AllOldReturnValuesOption;
export declare const putItemCommandReturnValuesOptions: readonly ["NONE", "ALL_OLD"];
export declare const putItemCommandReturnValuesOptionsSet: Set<PutItemCommandReturnValuesOption>;
export interface PutItemOptions<ENTITY extends Entity = Entity> {
    capacity?: CapacityOption;
    metrics?: MetricsOption;
    returnValues?: PutItemCommandReturnValuesOption;
    returnValuesOnConditionFalse?: ReturnValuesOnConditionFalseOption;
    condition?: Condition<ENTITY>;
    tableName?: string;
}
