"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PutItemCommand = void 0;
const lib_dynamodb_1 = require("@aws-sdk/lib-dynamodb");
const index_js_1 = require("../../../entity/actions/format/index.js");
const constants_js_1 = require("../../../entity/constants.js");
const decorator_js_1 = require("../../../entity/decorator.js");
const index_js_2 = require("../../../entity/index.js");
const index_js_3 = require("../../../errors/index.js");
const constants_js_2 = require("./constants.js");
const index_js_4 = require("./putItemParams/index.js");
class PutItemCommand extends index_js_2.EntityAction {
    constructor(entity, item, options = {}) {
        super(entity);
        this[constants_js_2.$item] = item;
        this[constants_js_2.$options] = options;
    }
    item(nextItem) {
        return new PutItemCommand(this.entity, nextItem, this[constants_js_2.$options]);
    }
    options(nextOptions) {
        return new PutItemCommand(this.entity, this[constants_js_2.$item], nextOptions);
    }
    [constants_js_1.$sentArgs]() {
        if (!this[constants_js_2.$item]) {
            throw new index_js_3.DynamoDBToolboxError('actions.incompleteAction', {
                message: 'PutItemCommand incomplete: Missing "item" property'
            });
        }
        return [this[constants_js_2.$item], this[constants_js_2.$options]];
    }
    params() {
        const [item, options] = this[constants_js_1.$sentArgs]();
        return (0, index_js_4.putItemParams)(this.entity, item, options);
    }
    async send(documentClientOptions) {
        const { ToolboxItem, ...putItemParams } = this.params();
        const commandOutput = await this.entity.table
            .getDocumentClient()
            .send(new lib_dynamodb_1.PutCommand(putItemParams), documentClientOptions);
        const { Attributes: attributes, ...restCommandOutput } = commandOutput;
        if (attributes === undefined) {
            return { ToolboxItem, ...restCommandOutput };
        }
        const formattedItem = new index_js_1.EntityFormatter(this.entity).format(attributes);
        return { ToolboxItem, Attributes: formattedItem, ...restCommandOutput };
    }
}
exports.PutItemCommand = PutItemCommand;
PutItemCommand.actionName = 'put';
__decorate([
    (0, decorator_js_1.interceptable)()
], PutItemCommand.prototype, "send", null);
