import { EntityAction } from '../../../../entity/index.js';
import type { Entity, KeyInputItem } from '../../../../entity/index.js';
import type { NonNull } from '../../../../types/nonNull.js';
import type { TransactGetItem } from '../transaction.js';
import { $key, $options } from './constants.js';
import type { GetTransactionOptions } from './options.js';
export declare class GetTransaction<ENTITY extends Entity = Entity, OPTIONS extends GetTransactionOptions<ENTITY> = GetTransactionOptions<ENTITY>> extends EntityAction<ENTITY> {
    static actionName: "transactGet";
    [$key]?: KeyInputItem<ENTITY>;
    [$options]: OPTIONS;
    constructor(entity: ENTITY, key?: KeyInputItem<ENTITY>, options?: OPTIONS);
    key(nextKey: KeyInputItem<ENTITY>): GetTransaction<ENTITY>;
    options<NEXT_OPTIONS extends GetTransactionOptions<ENTITY>>(nextOptions: NEXT_OPTIONS): GetTransaction<ENTITY, NEXT_OPTIONS>;
    params(): NonNull<TransactGetItem, 'Get'>;
}
