import type { Condition } from '../../../entity/actions/parseCondition/index.js';
import type { Entity } from '../../../entity/index.js';
import type { ReturnValuesOnConditionFalseOption } from '../../../options/returnValuesOnConditionFalse.js';
import type { TransactWriteItem } from '../transactWrite/transaction.js';
export interface PutTransactionOptions<ENTITY extends Entity = Entity> {
    condition?: Condition<ENTITY>;
    returnValuesOnConditionFalse?: ReturnValuesOnConditionFalseOption;
    tableName?: string;
}
type OptionsParser = <ENTITY extends Entity>(entity: ENTITY, options: PutTransactionOptions<ENTITY>) => Omit<NonNullable<TransactWriteItem['Put']>, 'TableName' | 'Item'>;
export declare const parseOptions: OptionsParser;
export {};
