"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PutTransaction = void 0;
const index_js_1 = require("../../../entity/actions/parse/index.js");
const index_js_2 = require("../../../errors/index.js");
const transaction_js_1 = require("../transactWrite/transaction.js");
const constants_js_1 = require("./constants.js");
const options_js_1 = require("./options.js");
class PutTransaction extends transaction_js_1.WriteTransaction {
    constructor(entity, item, options = {}) {
        super(entity);
        this[constants_js_1.$item] = item;
        this[constants_js_1.$options] = options;
    }
    item(nextItem) {
        return new PutTransaction(this.entity, nextItem, this[constants_js_1.$options]);
    }
    options(nextOptions) {
        return new PutTransaction(this.entity, this[constants_js_1.$item], nextOptions);
    }
    params() {
        var _a;
        if (!this[constants_js_1.$item]) {
            throw new index_js_2.DynamoDBToolboxError('actions.incompleteAction', {
                message: 'PutTransaction incomplete: Missing "item" property'
            });
        }
        const options = this[constants_js_1.$options];
        const { parsedItem, item } = this.entity.build(index_js_1.EntityParser).parse(this[constants_js_1.$item]);
        const awsOptions = (0, options_js_1.parseOptions)(this.entity, options);
        return {
            ToolboxItem: parsedItem,
            Put: {
                TableName: (_a = options === null || options === void 0 ? void 0 : options.tableName) !== null && _a !== void 0 ? _a : this.entity.table.getName(),
                Item: item,
                ...awsOptions
            }
        };
    }
}
exports.PutTransaction = PutTransaction;
PutTransaction.actionName = 'transactPut';
