"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseCapacityOption = exports.capacityOptionsSet = exports.capacityOptions = void 0;
const dynamoDBToolboxError_js_1 = require("../errors/dynamoDBToolboxError.js");
exports.capacityOptions = [
    'NONE',
    'TOTAL',
    'INDEXES'
];
exports.capacityOptionsSet = new Set(exports.capacityOptions);
const parseCapacityOption = (capacity) => {
    if (!exports.capacityOptionsSet.has(capacity)) {
        throw new dynamoDBToolboxError_js_1.DynamoDBToolboxError('options.invalidCapacityOption', {
            message: `Invalid capacity option: '${String(capacity)}'. 'capacity' must be one of: ${[
                ...exports.capacityOptionsSet
            ].join(', ')}.`,
            payload: { capacity }
        });
    }
    return capacity;
};
exports.parseCapacityOption = parseCapacityOption;
