"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseLimitOption = void 0;
const dynamoDBToolboxError_js_1 = require("../errors/dynamoDBToolboxError.js");
const isInteger_js_1 = require("../utils/validation/isInteger.js");
const parseLimitOption = (limit) => {
    if (!(0, isInteger_js_1.isInteger)(limit) || limit <= 0) {
        throw new dynamoDBToolboxError_js_1.DynamoDBToolboxError('options.invalidLimitOption', {
            message: `Invalid limit option: '${String(limit)}'. 'limit' must be an integer > 0.`,
            payload: { limit }
        });
    }
    return limit;
};
exports.parseLimitOption = parseLimitOption;
