"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseReturnValuesOnConditionFalseOption = void 0;
const dynamoDBToolboxError_js_1 = require("../errors/dynamoDBToolboxError.js");
const returnValuesOnConditionFalseOptions = new Set([
    'NONE',
    'ALL_OLD'
]);
const parseReturnValuesOnConditionFalseOption = (returnValues) => {
    if (!returnValuesOnConditionFalseOptions.has(returnValues)) {
        throw new dynamoDBToolboxError_js_1.DynamoDBToolboxError('options.invalidReturnValuesOnConditionFalseOption', {
            message: `Invalid returnValues option: '${String(returnValues)}'. 'returnValuesOnConditionFalse' must be one of: ${[...returnValuesOnConditionFalseOptions].join(', ')}.`,
            payload: { returnValues }
        });
    }
    return returnValues;
};
exports.parseReturnValuesOnConditionFalseOption = parseReturnValuesOnConditionFalseOption;
