"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseTableNameOption = void 0;
const dynamoDBToolboxError_js_1 = require("../errors/dynamoDBToolboxError.js");
const isString_js_1 = require("../utils/validation/isString.js");
const parseTableNameOption = (tableName) => {
    if (!(0, isString_js_1.isString)(tableName)) {
        throw new dynamoDBToolboxError_js_1.DynamoDBToolboxError('options.invalidTableNameOption', {
            message: `Invalid tableName option: '${String(tableName)}'. 'tableName' must be a string.`,
            payload: { tableName }
        });
    }
    return tableName;
};
exports.parseTableNameOption = parseTableNameOption;
