"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAnyOfSchemaDTO = void 0;
const schema_js_1 = require("./schema.js");
const utils_js_1 = require("./utils.js");
/**
 * @debt feature "handle defaults, links & validators DTOs"
 */
const getAnyOfSchemaDTO = (schema) => {
    const defaultsDTO = (0, utils_js_1.getDefaultsDTO)(schema);
    const { required, hidden, key, savedAs, discriminator } = schema.props;
    return {
        type: 'anyOf',
        elements: schema.elements.map(schema_js_1.getSchemaDTO),
        ...(required !== undefined && required !== 'atLeastOnce' ? { required } : {}),
        ...(hidden !== undefined && hidden ? { hidden } : {}),
        ...(key !== undefined && key ? { key } : {}),
        ...(savedAs !== undefined ? { savedAs } : {}),
        ...(discriminator !== undefined ? { discriminator } : {}),
        ...defaultsDTO
    };
};
exports.getAnyOfSchemaDTO = getAnyOfSchemaDTO;
