"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFormattedMapJSONSchema = void 0;
const schema_js_1 = require("./schema.js");
const getFormattedMapJSONSchema = (schema) => {
    const displayedAttrEntries = Object.entries(schema.attributes).filter(([, attr]) => !attr.props.hidden);
    const requiredProperties = displayedAttrEntries
        .filter(([, { props }]) => props.required !== 'never')
        .map(([attributeName]) => attributeName);
    return {
        type: 'object',
        properties: Object.fromEntries(displayedAttrEntries.map(([attributeName, attribute]) => [
            attributeName,
            (0, schema_js_1.getFormattedValueJSONSchema)(attribute)
        ])),
        ...(requiredProperties.length > 0 ? { required: requiredProperties } : {})
    };
};
exports.getFormattedMapJSONSchema = getFormattedMapJSONSchema;
