import type { RecordSchema } from '../../../../schema/index.js';
import type { ComputeObject } from '../../../../types/computeObject.js';
import type { FormattedValueJSONSchema } from './schema.js';
export type FormattedRecordJSONSchema<SCHEMA extends RecordSchema> = ComputeObject<{
    type: 'object';
    propertyNames: FormattedValueJSONSchema<SCHEMA['keys']>;
    additionalProperties: FormattedValueJSONSchema<SCHEMA['elements']>;
}>;
export declare const getFormattedRecordJSONSchema: <SCHEMA extends RecordSchema>(schema: SCHEMA) => FormattedRecordJSONSchema<SCHEMA>;
