"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionParser = void 0;
const index_js_1 = require("../../../schema/index.js");
const expressCondition_js_1 = require("./expressCondition/expressCondition.js");
const index_js_2 = require("./transformCondition/index.js");
class ConditionParser extends index_js_1.SchemaAction {
    static express(condition, expressionId = '') {
        return (0, expressCondition_js_1.expressCondition)(condition, expressionId);
    }
    transform(condition) {
        return (0, index_js_2.transformCondition)(this.schema, condition);
    }
    parse(condition, { expressionId } = {}) {
        return ConditionParser.express(this.transform(condition), expressionId);
    }
}
exports.ConditionParser = ConditionParser;
ConditionParser.actionName = 'parseCondition';
