"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.expressBetweenCondition = void 0;
const utils_js_1 = require("./utils.js");
const expressBetweenCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { between } = condition;
    const [left, right] = between;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' BETWEEN ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(left, prefix, state);
    ConditionExpression += ' AND ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(right, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressBetweenCondition = expressBetweenCondition;
