"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.expressNeCondition = exports.expressEqCondition = void 0;
const utils_js_1 = require("./utils.js");
const expressEqCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { eq } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' = ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(eq, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressEqCondition = expressEqCondition;
const expressNeCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { ne } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' <> ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(ne, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressNeCondition = expressNeCondition;
