"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.expressInCondition = void 0;
const utils_js_1 = require("./utils.js");
const expressInCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { in: range } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' IN (';
    ConditionExpression += range
        .map(rangeValue => (0, utils_js_1.attrOrValueTokens)(rangeValue, prefix, state))
        .join(', ');
    ConditionExpression += ')';
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressInCondition = expressInCondition;
