"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.expressLtCondition = exports.expressLteCondition = exports.expressGtCondition = exports.expressGteCondition = void 0;
const utils_js_1 = require("./utils.js");
const expressGteCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { gte } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' >= ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(gte, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressGteCondition = expressGteCondition;
const expressGtCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { gt } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' > ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(gt, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressGtCondition = expressGtCondition;
const expressLteCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { lte } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' <= ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(lte, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressLteCondition = expressLteCondition;
const expressLtCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { lt } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += (0, utils_js_1.pathTokens)(attr, prefix, state, size);
    ConditionExpression += ' < ';
    ConditionExpression += (0, utils_js_1.attrOrValueTokens)(lt, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
exports.expressLtCondition = expressLtCondition;
