"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformTypeCondition = void 0;
const index_js_1 = require("../../../../../schema/actions/finder/index.js");
const index_js_2 = require("../../../../../schema/actions/parse/index.js");
const deduper_js_1 = require("../../../../../schema/actions/utils/deduper.js");
const schema_js_1 = require("../../../../../schema/string/schema.js");
const utils_js_1 = require("./utils.js");
const typeSchema = new schema_js_1.StringSchema({
    enum: ['S', 'SS', 'N', 'NS', 'B', 'BS', 'BOOL', 'NULL', 'L', 'M']
});
const typeParser = new index_js_2.Parser(typeSchema);
const transformTypeCondition = (schema, condition) => {
    const conditions = new deduper_js_1.Deduper();
    const schemaFinder = new index_js_1.Finder(schema);
    const { type: formattedType } = condition;
    const attributePath = condition.attr;
    const subSchemas = schemaFinder.search(attributePath);
    for (const subSchema of subSchemas) {
        const path = subSchema.transformedPath.strPath;
        const type = typeParser.parse(formattedType, { fill: false, transform: false });
        conditions.push({ attr: path, type });
    }
    return (0, utils_js_1.joinDedupedConditions)(conditions, attributePath);
};
exports.transformTypeCondition = transformTypeCondition;
