import { z } from 'zod';
import type { BinarySchema } from '../../../../schema/index.js';
import type { WithValidate } from '../utils.js';
import type { ZodFormatterOptions } from './types.js';
import type { WithDecoding, WithOptional } from './utils.js';
export type BinaryZodFormatter<SCHEMA extends BinarySchema, OPTIONS extends ZodFormatterOptions = {}> = WithDecoding<SCHEMA, OPTIONS, WithOptional<SCHEMA, OPTIONS, WithValidate<SCHEMA, z.ZodType<Uint8Array>>>>;
export declare const binaryZodFormatter: (schema: BinarySchema, options?: ZodFormatterOptions) => z.ZodTypeAny;
