"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withValidate = void 0;
const withValidate = (schema, zodSchema) => {
    const { key = false, keyValidator, putValidator } = schema.props;
    if (key && keyValidator !== undefined) {
        return zodSchema.refine(input => keyValidator(input, schema));
    }
    if (!key && putValidator !== undefined) {
        return zodSchema.refine(input => putValidator(input, schema));
    }
    return zodSchema;
};
exports.withValidate = withValidate;
