import type { SchemaProps, SchemaRequiredProp } from '../types/index.js';
import type { MapAttributes } from './types.js';
export declare class MapSchema<ATTRIBUTES extends MapAttributes = MapAttributes, PROPS extends SchemaProps = SchemaProps> {
    type: 'map';
    attributes: ATTRIBUTES;
    props: PROPS;
    keyAttributeNames: Set<string>;
    savedAttributeNames: Set<string>;
    requiredAttributeNames: Record<SchemaRequiredProp, Set<string>>;
    constructor(attributes: ATTRIBUTES, props: PROPS);
    get checked(): boolean;
    check(path?: string): void;
}
