"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NullSchema = void 0;
const check_js_1 = require("../primitive/check.js");
class NullSchema {
    constructor(props) {
        this.type = 'null';
        this.props = props;
    }
    get checked() {
        return Object.isFrozen(this.props);
    }
    check(path) {
        if (this.checked) {
            return;
        }
        (0, check_js_1.checkPrimitiveSchema)(this, path);
        Object.freeze(this.props);
    }
}
exports.NullSchema = NullSchema;
