import type { BatchWriteCommandInput, BatchWriteCommandOutput, DynamoDBDocumentClient } from '@aws-sdk/lib-dynamodb';
import type { CapacityOption } from '../../../options/capacity.js';
import type { MetricsOption } from '../../../options/metrics.js';
import type { DocumentClientOptions } from '../../../types/documentClientOptions.js';
import { BatchWriteCommand } from './batchWriteCommand.js';
export type ExecuteBatchWriteInput = [ExecuteBatchWriteOptions, ...BatchWriteCommand[]] | BatchWriteCommand[];
export interface ExecuteBatchWriteOptions extends DocumentClientOptions {
    capacity?: CapacityOption;
    metrics?: MetricsOption;
    documentClient?: DynamoDBDocumentClient;
    maxAttempts?: number;
}
export declare const execute: (..._commands: ExecuteBatchWriteInput) => Promise<BatchWriteCommandOutput>;
export declare const getCommandInput: (commands: BatchWriteCommand[], options?: ExecuteBatchWriteOptions) => BatchWriteCommandInput;
