import { DatabaseAction } from '../../../database/index.js';
import { addAccessPatternTool } from './addAccessPatternTool.js';
import { addEntityTools } from './addEntityTools/index.js';
export class MCPToolkit extends DatabaseAction {
    addTools(mcpServer, options = {}) {
        for (const [dbTableKey, dbTable] of Object.entries(this.database.tables)) {
            for (const entity of Object.values(dbTable.entities)) {
                addEntityTools(mcpServer, entity, { ...options, dbTableKey });
            }
            for (const [dbAccessPatternKey, accessPattern] of Object.entries(dbTable.accessPatterns)) {
                addAccessPatternTool(mcpServer, accessPattern, { dbTableKey, dbAccessPatternKey });
            }
        }
        return this;
    }
}
