import type { Database } from '../../../database/database.js';
import { DatabaseAction } from '../../../database/database.js';
import { $awsAccount } from './constants.js';
import type { AWSAccount } from './types.js';
export declare class Synchronizer<DATABASE extends Database> extends DatabaseAction<DATABASE> {
    static actionName: "synchronize";
    apiUrl: string;
    [$awsAccount]?: AWSAccount;
    constructor(database: DATABASE, awsAccount?: AWSAccount);
    awsAccount(awsAccount: AWSAccount): Synchronizer<DATABASE>;
    sync({ apiKey, deleteUnknownEntities, fetch: _fetch }: {
        apiKey: string;
        deleteUnknownEntities?: boolean;
        fetch?: typeof fetch;
    }): Promise<void>;
}
