import type { Entity } from '../../../entity/index.js';
import { EntityAction } from '../../../entity/index.js';
import type { InputValue, Schema, TransformedValue } from '../../../schema/index.js';
import type { IQueryCommand, Query, QueryOptions } from '../../../table/actions/query/index.js';
import { QueryCommand } from '../../../table/actions/query/queryCommand.js';
import { $meta, $options, $pattern, $schema } from './constants.js';
interface AccessPatternMetadata {
    title?: string;
    description?: string;
}
export declare class IAccessPattern<ENTITY extends Entity = Entity, SCHEMA extends Schema = Schema, QUERY extends Query<ENTITY['table']> = Query<ENTITY['table']>, OPTIONS extends QueryOptions<ENTITY['table'], [ENTITY], QUERY> = QueryOptions<ENTITY['table'], [
    ENTITY
], QUERY>> extends EntityAction<ENTITY> {
    static actionName: "access-pattern";
    [$schema]?: SCHEMA;
    [$pattern]?: (input: Schema extends SCHEMA ? any : TransformedValue<SCHEMA>) => QUERY;
    [$options]: OPTIONS;
    [$meta]: AccessPatternMetadata;
    constructor(entity: ENTITY, schema?: SCHEMA, pattern?: (input: TransformedValue<SCHEMA>) => QUERY, options?: OPTIONS, meta?: AccessPatternMetadata);
    query(input: InputValue<SCHEMA>): Entity extends ENTITY ? IQueryCommand : QueryCommand<ENTITY['table'], [ENTITY], QUERY, OPTIONS>;
}
export declare class AccessPattern<ENTITY extends Entity = Entity, SCHEMA extends Schema = Schema, QUERY extends Query<ENTITY['table']> = Query<ENTITY['table']>, OPTIONS extends QueryOptions<ENTITY['table'], [ENTITY], QUERY> = QueryOptions<ENTITY['table'], [
    ENTITY
], QUERY>> extends IAccessPattern<ENTITY, SCHEMA, QUERY, OPTIONS> {
    constructor(entity: ENTITY, schema?: SCHEMA, pattern?: (input: TransformedValue<SCHEMA>) => QUERY, options?: OPTIONS, meta?: AccessPatternMetadata);
    schema<NEXT_SCHEMA extends Schema>(nextSchema: NEXT_SCHEMA): AccessPattern<ENTITY, NEXT_SCHEMA, QUERY, OPTIONS>;
    pattern<NEXT_QUERY extends Query<ENTITY['table']>>(nextPattern: (input: TransformedValue<SCHEMA>) => NEXT_QUERY): AccessPattern<ENTITY, SCHEMA, NEXT_QUERY, OPTIONS>;
    options<NEXT_OPTIONS extends QueryOptions<ENTITY['table'], [ENTITY], QUERY>>(nextOptions: NEXT_OPTIONS): AccessPattern<ENTITY, SCHEMA, QUERY, NEXT_OPTIONS>;
    meta(nextMeta: AccessPatternMetadata): AccessPattern<ENTITY, SCHEMA, QUERY, OPTIONS>;
}
export {};
