import type { Entity } from '../../../entity/index.js';
import { EntityAction } from '../../../entity/index.js';
import type { ConditionExpression, ParseConditionOptions, SchemaCondition } from '../../../schema/actions/parseCondition/index.js';
import { ConditionParser } from '../../../schema/actions/parseCondition/index.js';
import { $conditionParser } from './constants.js';
export declare class EntityConditionParser<ENTITY extends Entity = Entity> extends EntityAction<ENTITY> {
    static actionName: 'parseCondition';
    static express(condition: SchemaCondition, expressionId?: string): ConditionExpression;
    [$conditionParser]: ConditionParser<ENTITY['schema']>;
    constructor(entity: ENTITY);
    transform(condition: SchemaCondition): SchemaCondition;
    parse(condition: SchemaCondition, options?: ParseConditionOptions): ConditionExpression;
}
export type Condition<ENTITY extends Entity = Entity> = SchemaCondition<ENTITY['schema']>;
