import { EntityAction } from '../../../entity/index.js';
import { ConditionParser } from '../../../schema/actions/parseCondition/index.js';
import { $conditionParser } from './constants.js';
export class EntityConditionParser extends EntityAction {
    static express(condition, expressionId = '') {
        return ConditionParser.express(condition, expressionId);
    }
    constructor(entity) {
        super(entity);
        this[$conditionParser] = new ConditionParser(entity.schema);
    }
    transform(condition) {
        return this[$conditionParser].transform(condition);
    }
    parse(condition, options = {}) {
        return this[$conditionParser].parse(condition, options);
    }
}
