import type { Condition } from '../../../entity/actions/parseCondition/index.js';
import type { Entity } from '../../../entity/index.js';
import type { ReturnValuesOnConditionFalseOption } from '../../../options/returnValuesOnConditionFalse.js';
import type { TransactWriteItem } from '../transactWrite/transaction.js';
export interface UpdateTransactionOptions<ENTITY extends Entity = Entity> {
    condition?: Condition<ENTITY>;
    returnValuesOnConditionFalse?: ReturnValuesOnConditionFalseOption;
    tableName?: string;
}
type OptionsParser = <ENTITY extends Entity>(entity: ENTITY, options: UpdateTransactionOptions<ENTITY>) => Omit<NonNullable<TransactWriteItem['Update']>, 'TableName' | 'Key' | 'UpdateExpression'>;
export declare const parseOptions: OptionsParser;
export {};
