import { DynamoDBToolboxError } from '../errors/dynamoDBToolboxError.js';
export const capacityOptions = [
    'NONE',
    'TOTAL',
    'INDEXES'
];
export const capacityOptionsSet = new Set(capacityOptions);
export const parseCapacityOption = (capacity) => {
    if (!capacityOptionsSet.has(capacity)) {
        throw new DynamoDBToolboxError('options.invalidCapacityOption', {
            message: `Invalid capacity option: '${String(capacity)}'. 'capacity' must be one of: ${[
                ...capacityOptionsSet
            ].join(', ')}.`,
            payload: { capacity }
        });
    }
    return capacity;
};
