import { DynamoDBToolboxError } from '../errors/dynamoDBToolboxError.js';
export const metricsOptions = ['NONE', 'SIZE'];
export const metricsOptionsSet = new Set(metricsOptions);
export const parseMetricsOption = (metrics) => {
    if (!metricsOptionsSet.has(metrics)) {
        throw new DynamoDBToolboxError('options.invalidMetricsOption', {
            message: `Invalid metrics option: '${String(metrics)}'. 'metrics' must be one of: ${[
                ...metricsOptionsSet
            ].join(', ')}.`,
            payload: { metrics }
        });
    }
    return metrics;
};
