import { DynamoDBToolboxError } from '../errors/dynamoDBToolboxError.js';
export const noEntityMatchBehaviorSet = new Set(['DISCARD', 'THROW']);
export const parseNoEntityMatchBehavior = (noEntityMatchBehavior) => {
    if (!noEntityMatchBehaviorSet.has(noEntityMatchBehavior)) {
        throw new DynamoDBToolboxError('options.invalidNoEntityMatchBehaviorOption', {
            message: `Invalid noEntityMatchBehavior option: '${String(noEntityMatchBehavior)}'. 'noEntityMatchBehavior' must be one of: ${[
                ...noEntityMatchBehaviorSet
            ].join(', ')}.`,
            payload: { noEntityMatchBehavior }
        });
    }
    return noEntityMatchBehavior;
};
