import { DynamoDBToolboxError } from '../errors/dynamoDBToolboxError.js';
export const parseReturnValuesOption = (allowedReturnValuesOptions, returnValues) => {
    if (!allowedReturnValuesOptions.has(returnValues)) {
        throw new DynamoDBToolboxError('options.invalidReturnValuesOption', {
            message: `Invalid returnValues option: '${String(returnValues)}'. 'returnValues' must be one of: ${[...allowedReturnValuesOptions].join(', ')}.`,
            payload: { returnValues }
        });
    }
    return returnValues;
};
