import { getSchemaDTO } from './schema.js';
import { getDefaultsDTO } from './utils.js';
/**
 * @debt feature "handle defaults, links & validators DTOs"
 */
export const getAnyOfSchemaDTO = (schema) => {
    const defaultsDTO = getDefaultsDTO(schema);
    const { required, hidden, key, savedAs, discriminator } = schema.props;
    return {
        type: 'anyOf',
        elements: schema.elements.map(getSchemaDTO),
        ...(required !== undefined && required !== 'atLeastOnce' ? { required } : {}),
        ...(hidden !== undefined && hidden ? { hidden } : {}),
        ...(key !== undefined && key ? { key } : {}),
        ...(savedAs !== undefined ? { savedAs } : {}),
        ...(discriminator !== undefined ? { discriminator } : {}),
        ...defaultsDTO
    };
};
