import { getSchemaDTO } from './schema.js';
import { getDefaultsDTO } from './utils.js';
/**
 * @debt feature "handle defaults, links & validators DTOs"
 */
export const getRecordSchemaDTO = (schema) => {
    const defaultsDTO = getDefaultsDTO(schema);
    const { required, hidden, key, savedAs } = schema.props;
    return {
        type: 'record',
        keys: getSchemaDTO(schema.keys),
        elements: getSchemaDTO(schema.elements),
        ...(required !== undefined && required !== 'atLeastOnce' ? { required } : {}),
        ...(hidden !== undefined && hidden ? { hidden } : {}),
        ...(key !== undefined && key ? { key } : {}),
        ...(savedAs !== undefined ? { savedAs } : {}),
        ...defaultsDTO
    };
};
