import { isFunction } from '../../../../utils/validation/isFunction.js';
export const getDefaultsDTO = (schema) => {
    const defaultsDTO = {};
    for (const mode of ['keyDefault', 'putDefault', 'updateDefault']) {
        const modeDefault = schema.props[mode];
        if (modeDefault === undefined) {
            continue;
        }
        defaultsDTO[mode] = isFunction(modeDefault)
            ? { defaulterId: 'custom' }
            : { defaulterId: 'value', value: modeDefault };
    }
    return defaultsDTO;
};
