import { attrOrValueTokens, pathTokens } from './utils.js';
export const expressEqCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { eq } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += pathTokens(attr, prefix, state, size);
    ConditionExpression += ' = ';
    ConditionExpression += attrOrValueTokens(eq, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
export const expressNeCondition = (condition, prefix = '', state) => {
    let ConditionExpression = '';
    const { ne } = condition;
    const size = 'size' in condition;
    const attr = size ? condition.size : condition.attr;
    ConditionExpression += pathTokens(attr, prefix, state, size);
    ConditionExpression += ' <> ';
    ConditionExpression += attrOrValueTokens(ne, prefix, state);
    return {
        ConditionExpression,
        ExpressionAttributeNames: state.ExpressionAttributeNames,
        ExpressionAttributeValues: state.ExpressionAttributeValues
    };
};
