export class Deduper {
    constructor({ serializer = JSON.stringify } = {}) {
        this.values = [];
        this.serializedValues = new Set();
        this.serializer = serializer;
    }
    push(value) {
        const serializedValue = this.serializer(value);
        const hit = this.serializedValues.has(serializedValue);
        if (!hit) {
            this.values.push(value);
            this.serializedValues.add(serializedValue);
        }
        return hit;
    }
}
