import type { Schema } from '../types/index.js';
import { $discriminations_, $discriminators, $discriminators_ } from './constants.js';
import type { AnyOfSchemaProps } from './types.js';
export declare class AnyOfSchema<ELEMENTS extends Schema[] = Schema[], PROPS extends AnyOfSchemaProps = AnyOfSchemaProps> {
    type: 'anyOf';
    elements: ELEMENTS;
    props: PROPS;
    [$discriminators_]?: Record<string, string>;
    [$discriminations_]?: Record<string, Schema>;
    constructor(elements: ELEMENTS, props: PROPS);
    get checked(): boolean;
    check(path?: string): void;
    get [$discriminators](): Record<string, string>;
    match(value: string): Schema | undefined;
}
