import type { StringSchema } from '../string/index.js';
import type { Schema } from '../types/index.js';
import type { RecordSchemaProps } from './types.js';
export declare class RecordSchema<KEYS extends StringSchema = StringSchema, ELEMENTS extends Schema = Schema, PROPS extends RecordSchemaProps = RecordSchemaProps> {
    type: 'record';
    keys: KEYS;
    elements: ELEMENTS;
    props: PROPS;
    constructor(keys: KEYS, elements: ELEMENTS, props: PROPS);
    get checked(): boolean;
    check(path?: string): void;
}
