import type { StringSchema, StringSchemaProps } from '../string/index.js';
import type { AtLeastOnce, Schema, SchemaProps } from '../types/index.js';
export interface RecordSchemaProps extends SchemaProps {
    partial?: boolean;
}
interface RecordKeyAndElementProps extends SchemaProps {
    required?: AtLeastOnce;
    hidden?: false;
    key?: false;
    savedAs?: undefined;
    keyDefault?: undefined;
    putDefault?: undefined;
    updateDefault?: undefined;
    keyLink?: undefined;
    putLink?: undefined;
    updateLink?: undefined;
}
export type RecordElementSchema = Schema & {
    props: RecordKeyAndElementProps;
};
export type RecordKeySchema = StringSchema<StringSchemaProps & RecordKeyAndElementProps>;
export {};
