import type { Index, Key } from '../../../table/index.js';
import { TableAction } from '../../../table/index.js';
import type { Table } from '../../../table/table.js';
export interface ITableDTO {
    tableName?: string | undefined;
    partitionKey: Key;
    sortKey?: Key;
    indexes?: Record<string, Index>;
    entityAttributeSavedAs?: string;
}
export declare class TableDTO<TABLE extends Table = Table> extends TableAction<TABLE> implements ITableDTO {
    static actionName: "dto";
    tableName?: string;
    partitionKey: ITableDTO['partitionKey'];
    sortKey?: ITableDTO['sortKey'];
    indexes?: ITableDTO['indexes'];
    entityAttributeSavedAs: string;
    constructor(table: TABLE);
    toJSON(): ITableDTO;
}
